﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
'v.0.21 Circuit component object: a rectangle + pins

#Event: Click
#Event: LongClick

Private Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	Public Name As String
	
	Public InternalView As Boolean
	Public mRoot As B4XView
	Public mRect As b4xVectEdit_rect
	Public PinIn1, PinIn2, PinIn3, PinOut As b4xVectEdit_pin
	
	Private DownX, DownY As Int, Dragging As Boolean, DraggingStart As Long
	Private GridSize As Int = 10dip
	Private TextLinesGap As Int = 15dip
	Private MouseClickTimer As Timer	'LongTap timer for Android together with dragging
	Public mName As B4XView
	Public TextSize As Int = 7
	
	'Public Internals() As b4xVectEdit_component
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	MouseClickTimer.Initialize("MouseClickTimer", 500)
	Log("xui.Scale = " & xui.Scale)
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	mBase.SetColorAndBorder(xui.Color_Transparent, 1dip, xui.Color_Transparent, 0)	'transparent container xui.Color_ARGB(50, 0, 0, 0)
    Tag = mBase.Tag
    mBase.Tag = Me
	
	mRoot = xui.CreatePanel("mRoot")
	mBase.AddView(mRoot, 0, 0, mBase.Width, mBase.Height)	'component is on the base
	
	#if B4A
		Dim r As Reflector
		r.Target = mRoot
		r.SetOnTouchListener("mRoot_Touch") 'https://www.b4x.com/android/forum/threads/how-correct-crossplatform-mouse-object-moving-dragging-by-_touch-event.160800/#post-986957
	#End If
	
	'left input pins of this component
	PinIn1.Initialize(Me, "Pin")
	PinIn1.Name = "PinIn1"
	PinIn1.DesignerCreateView(mRoot, Null, Null)
	PinIn1.mRoot.Top = mRoot.Top + TextLinesGap * 3
	
	PinIn2.Initialize(Me, "Pin")
	PinIn2.Name = "PinIn2"
	PinIn2.DesignerCreateView(mRoot, Null, Null)
	PinIn2.mRoot.Top = PinIn1.mRoot.Top + TextLinesGap * 2
	
	PinIn3.Initialize(Me, "Pin")
	PinIn3.Name = "PinIn3"
	PinIn3.DesignerCreateView(mRoot, Null, Null)
	PinIn3.mRoot.Top = PinIn2.mRoot.Top + TextLinesGap * 2
	
	'right ouput pin of this component
	PinOut.Initialize(Me, "Pin")
	PinOut.Name = "PinOut"
	PinOut.DesignerCreateView(mRoot, Null, Null)
	PinOut.mRoot.Top = mRoot.Top + TextLinesGap * 3
	PinOut.mRoot.Left = mRoot.Width - PinOut.Length
	
	'rectangle of this component
	mRect.Initialize(Me, "mRect")
	mRect.SideGap = PinOut.PointSizePx
	mRect.DesignerCreateView(mRoot, Null, Null)
	
	Dim Lbl As Label
	Lbl.Initialize("mName")
	mName = Lbl
	mName.TextSize = TextSize
	Dim LabelWidth As Int = MeasureTextWidth(Name, xui.CreateDefaultFont(mName.TextSize + 1.5))
	mRoot.AddView(mName, mRect.mRect.Left + mRect.BorderThicknessPx, mRect.mBase.Top + TextLinesGap, LabelWidth, TextLinesGap)	'mRoot.AddView(mName, mRoot.Width - LabelWidth, 0, LabelWidth, TextLinesGap)
	mName.Text = Name
	
	PinIn1.mRoot.BringToFront
	PinIn2.mRoot.BringToFront
	PinIn3.mRoot.BringToFront
	PinOut.mRoot.BringToFront
	
	DownX = mRoot.Left
	DownY = mRoot.Top
	Base_Resize(mBase.Width, mBase.Height)
End Sub


'TOUCH_ACTION_DOWN = 0
'TOUCH_ACTION_MOVE = 2
'TOUCH_ACTION_UP = 1
'TOUCH_ACTION_MOVE_NOTOUCH = 100
#if B4A
Private Sub mRoot_Touch (o As Object, ACTION As Int, x As Float, y As Float, motion As Object) As Boolean
#else
Private Sub mRoot_Touch (Action As Int, X As Float, Y As Float)
#end if

	If Action = mRoot.TOUCH_ACTION_DOWN Then
		'mRoot.BringToFront
		Dragging = True
		DownX = X
		DownY = Y
		DraggingStart = DateTime.Now
		Check_LongClick	'checking if LongTap was made
	Else If Action = mRoot.TOUCH_ACTION_UP Then
		Dragging = False
		MouseClickTimer.Enabled = False	'no LongTap
	Else If Dragging And Action = mRoot.TOUCH_ACTION_MOVE Then
		#if B4A
			If InternalView Then Return True
		#else
			If InternalView Then Return
		#end if
	
		MouseClickTimer.Enabled = False	'no LongTap
		'mRoot.Left = ApplyGrid(Max(0, Min(mRoot.Parent.Width - mRoot.Width, mRoot.Left + X - DownX)))  'limited
		'mRoot.Top = ApplyGrid(Max(0, Min(mRoot.Parent.Height - mRoot.Height, mRoot.Top + Y - DownY)))  'limited
		mRoot.Left = ApplyGrid(mRoot.Left + X - DownX)
		mRoot.Top = ApplyGrid(mRoot.Top + Y - DownY)
	End If
'	Log(mRoot.Left & "; " & mRoot.Top)
    #if B4A
	Return True
    #end if
End Sub

Private Sub Check_LongClick
	#if B4A
	MouseClickTimer.Enabled = True
	Wait For MouseClickTimer_Tick
	MouseClickTimer.Enabled = False
	If (DateTime.Now - DraggingStart) > MouseClickTimer.Interval And (DateTime.Now - DraggingStart) < 1000 Then
		mRoot_LongClick
	End If
	#end if
End Sub

Private Sub ApplyGrid (x As Float) As Float
	Dim res As Float = x
	If GridSize > 0 Then
		res = x - (x Mod GridSize)
	End If
	Return res
End Sub

Sub Base_Resize (Width As Double, Height As Double)
	mRoot.SetLayoutAnimated(0, 0, 0, Width, Height)
	mRect.Base_Resize(Width, Height)
	PinOut.mRoot.Left = mRoot.Width - PinOut.Length
	Sleep(0)
End Sub

#if B4J
Private Sub mRoot_MouseClicked (EventData As MouseEvent)
	If Dragging Then Return
	If EventData.PrimaryButtonPressed Then
'		Log("mRoot click: " & Name)
'		If xui.SubExists(mCallBack, mEventmEventName & "_Click", 0) Then
'			CallSub(mCallBack, mEventmEventName & "_Click")
'		End If
	Else if EventData.SecondaryButtonPressed Then
		Log("mRoot longclick: " & Name)
		If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
			CallSub(mCallBack, mEventName & "_LongClick")
		End If
	End If
	EventData.Consume
End Sub
#else if B4A
Private Sub mRoot_Click
'	Log("mRoot click: " & Name)
'	If xui.SubExists(mCallBack, mEventmEventName & "_Click", 0) Then
'		CallSub(mCallBack, mEventmEventName & "_Click")
'	End If
End Sub
Private Sub mRoot_LongClick
	Log("mRoot longclick: " & Name)
	If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
		CallSub(mCallBack, mEventName & "_LongClick")
	End If
End Sub
#end if

'https://www.b4x.com/android/forum/threads/b4x-xui-add-measuretextwidth-and-measuretextheight-to-b4xcanvas.91865/#content
Private Sub MeasureTextWidth(Text As String, Font1 As B4XFont) As Int
#If B4A
	Private bmp As Bitmap
	bmp.InitializeMutable(1, 1)'ignore
	Private cvs As Canvas
	cvs.Initialize2(bmp)
	Return cvs.MeasureStringWidth(Text, Font1.ToNativeFont, Font1.Size)
#Else If B4i
    Return Text.MeasureWidth(Font1.ToNativeFont)
#Else If B4J
	Dim jo As JavaObject
	jo.InitializeNewInstance("javafx.scene.text.Text", Array(Text))
	jo.RunMethod("setFont",Array(Font1.ToNativeFont))
	jo.RunMethod("setLineSpacing",Array(0.0))
	jo.RunMethod("setWrappingWidth",Array(0.0))
	Dim Bounds As JavaObject = jo.RunMethod("getLayoutBounds",Null)
	Return Bounds.RunMethod("getWidth",Null)
#End If
End Sub


Private Sub Pin_Click
	Dim v As b4xVectEdit_pin = Sender
	Log(v.Name)
End Sub

Private Sub Pin_LongClick
	Dim v As b4xVectEdit_pin = Sender
	Log("Long:" & v.Name)
End Sub
