﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
'v.0.21 Pin object: line + two connection points

Private Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	Public Name As String = "Pin_" & DateTime.Now	'default auto-generated name
	Private TextLinesGap As Int = 15dip
	
	Public mLine, mPoint1, mPoint2 As B4XView, mRoot As B4XView
	Public LineThinknessPx As Int = 2dip
	Public LineLenghtPx As Int = 10dip
	Public LineColor As Int = xui.Color_Blue
	Public PointSizePx As Int = LineThinknessPx * 5
	
	Public mName As B4XView
	Public TextSize As Int = 7
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
    mBase.Tag = Me
	
	mRoot = xui.CreatePanel("mRoot")
	mBase.AddView(mRoot, 0, 0, mBase.Width, mBase.Height)
	mRoot.SetColorAndBorder(xui.Color_Transparent, 1dip, xui.Color_Transparent, 0)	'transparent container xui.Color_ARGB(50, 0, 199, 0)
	
	Dim Lbl As Label
	Lbl.Initialize("mName")
	mName = Lbl
	mName.TextSize = TextSize
	Dim LabelWidth As Int = MeasureTextWidth(Name, xui.CreateDefaultFont(mName.TextSize + 2))
	LineLenghtPx = LabelWidth + LineThinknessPx
	mRoot.AddView(mName, PointSizePx + LineThinknessPx, 0, LabelWidth, TextLinesGap)
	mName.Text = Name

	mPoint1 = xui.CreatePanel("mPoint1")
	mRoot.AddView(mPoint1, 0, TextLinesGap, PointSizePx, PointSizePx)
	mPoint1.SetColorAndBorder(xui.Color_Transparent, LineThinknessPx, LineColor, PointSizePx)	'Connection point1 as square
	mPoint1.BringToFront
	
	mLine = xui.CreatePanel("")
	mRoot.AddView(mLine, PointSizePx , (PointSizePx - LineThinknessPx) / 2 + TextLinesGap, LineLenghtPx, LineThinknessPx)
	mLine.SetColorAndBorder(LineColor, 0, LineColor, 0)    'line as rectangle between Points
	
	mPoint2 = xui.CreatePanel("mPoint2")
	mRoot.AddView(mPoint2, PointSizePx + LineLenghtPx, TextLinesGap, PointSizePx, PointSizePx)
	mPoint2.SetColorAndBorder(xui.Color_Transparent, LineThinknessPx, LineColor, PointSizePx)	'Connection point1 as square
	mPoint2.BringToFront
	
	mRoot.Width = mPoint2.Left + mPoint2.Width
	mRoot.Height = mPoint2.Top + mPoint2.Height
End Sub

Sub getLength As Float
	Return (PointSizePx * 2 + LineLenghtPx)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	mLine.SetLayoutAnimated(0, 0, 0, Width, Height)
	mRoot.Width = Width
	mRoot.Height = Height
	Sleep(0)
End Sub

#if B4J
Private Sub mRoot_MouseClicked (EventData As MouseEvent)
	If EventData.PrimaryButtonPressed Then
		Log("Pin click: " & Name)
		If xui.SubExists(mCallBack, mEventName & "_Click", 0) Then
			CallSub(mCallBack, mEventName & "_Click")
		End If
	Else if EventData.SecondaryButtonPressed Then
		Log("Pin longclick: " & Name)
		If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
			CallSub(mCallBack, mEventName & "_LongClick")
		End If
	End If
	EventData.Consume
End Sub
#else if B4A
Private Sub mRoot_Click
	Log("Pin click: " & Name)
	If xui.SubExists(mCallBack, mEventName & "_Click", 0) Then
		CallSub(mCallBack, mEventName & "_Click")
	End If
End Sub
Private Sub mRoot_LongClick
	Log("Pin longclick: " & Name)
	If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
		CallSub(mCallBack, mEventName & "_LongClick")
	End If
End Sub
#end if

#if B4J
Private Sub mPoint1_MouseClicked (EventData As MouseEvent)
	If EventData.PrimaryButtonPressed Then
		'Log("mPoint1 click: " & Name)
		If xui.SubExists(mCallBack, mEventName & "_Click", 0) Then
			CallSub(mCallBack, mEventName & "_Click")
		End If
	Else if EventData.SecondaryButtonPressed Then
		'Log("mPoint1 longclick: " & Name)
		If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
			CallSub(mCallBack, mEventName & "_LongClick")
		End If
	End If
	EventData.Consume
End Sub
#else if B4A
Private Sub mPoint1_Click
	'Log("mPoint1 click: " & Name)
	If xui.SubExists(mCallBack, mEventName & "_Click", 0) Then
		CallSub(mCallBack, mEventName & "_Click")
	End If
End Sub
Private Sub mPoint1_LongClick
	'Log("mPoint1 longclick: " & Name)
	If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
		CallSub(mCallBack, mEventName & "_LongClick")
	End If
End Sub
#end if

#if B4J
Private Sub mPoint2_MouseClicked (EventData As MouseEvent)
	If EventData.PrimaryButtonPressed Then
		'Log("mPoint2 click: " & Name)
		If xui.SubExists(mCallBack, mEventName & "_Click", 0) Then
			CallSub(mCallBack, mEventName & "_Click")
		End If
	Else if EventData.SecondaryButtonPressed Then
		'Log("mPoint2 longclick: " & Name)
		If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
			CallSub(mCallBack, mEventName & "_LongClick")
		End If
	End If
	EventData.Consume
End Sub
#else if B4A
Private Sub mPoint2_Click
	'Log("mPoint2 click: " & Name)
	If xui.SubExists(mCallBack, mEventName & "_Click", 0) Then
		CallSub(mCallBack, mEventName & "_Click")
	End If
End Sub
Private Sub mPoint2_LongClick
	'Log("mPoint2 longclick: " & Name)
	If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
		CallSub(mCallBack, mEventName & "_LongClick")
	End If
End Sub
#end if

'https://www.b4x.com/android/forum/threads/b4x-xui-add-measuretextwidth-and-measuretextheight-to-b4xcanvas.91865/#content
Private Sub MeasureTextWidth(Text As String, Font1 As B4XFont) As Int
#If B4A
	Private bmp As Bitmap
	bmp.InitializeMutable(1, 1)'ignore
	Private cvs As Canvas
	cvs.Initialize2(bmp)
	Return cvs.MeasureStringWidth(Text, Font1.ToNativeFont, Font1.Size)
#Else If B4i
    Return Text.MeasureWidth(Font1.ToNativeFont)
#Else If B4J
	Dim jo As JavaObject
	jo.InitializeNewInstance("javafx.scene.text.Text", Array(Text))
	jo.RunMethod("setFont",Array(Font1.ToNativeFont))
	jo.RunMethod("setLineSpacing",Array(0.0))
	jo.RunMethod("setWrappingWidth",Array(0.0))
	Dim Bounds As JavaObject = jo.RunMethod("getLayoutBounds",Null)
	Return Bounds.RunMethod("getWidth",Null)
#End If
End Sub